/**
 * 
 */
package org.richfaces.realworld.util;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.net.URLClassLoader;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Create;
import org.jboss.seam.annotations.Destroy;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.annotations.Startup;
import org.richfaces.realworld.service.Constants;


/**
 * @author Andrey Markavtsov
 *
 */

@Name("CopyImagesStuff")
@Scope(ScopeType.APPLICATION)
@Startup
public class CopyImageStuff {
	
	@Out(scope = ScopeType.APPLICATION)
	File uploadRoot;
	
	@Out(scope = ScopeType.APPLICATION)
	String uploadRootPath;
	
	String imageSrc;
	
	@Create
	public void create() throws Exception {
		resolveImageFolder();
		resolveUploadRoot();
		
		copyImages();
	}
	
	@Destroy
	public void destroy()throws IOException {
		FileUtils.deleteDirectory(uploadRoot, true);
	}
	
	void resolveImageFolder() {
		//TODO nick - what this cast is for?
		URLClassLoader loader = (URLClassLoader)getClass().getClassLoader();
		//TODO nick - rewrite that
		URL path = loader.getResource("");
		String classLoadPath = null;
		String realPath = null;
		
		if (path != null) {
			classLoadPath = path.getFile();
		}
		
		if (classLoadPath != null) {
			int index = classLoadPath.indexOf(Constants.WEB_INF);
			if (index != -1) {
				realPath = classLoadPath.substring(0, index + Constants.WEB_INF.length()) + Constants.IMAGE_FOLDER;
			}
		}
		
		if (realPath != null) {
			this.imageSrc = realPath;
		}else {
			throw new NullPointerException(Constants.UPLOAD_FOLDER_PATH_ERROR);
		}

	}
	
	void resolveUploadRoot()throws IOException {
		String property = System.getProperty(Constants.TEMP_DIR);
		if(!property.endsWith(File.separator)){
			property+=File.separator;
		}
		String uploadRootPath = property + Constants.REALWORLD_FOLDER + File.separator;
		if (uploadRootPath != null) {
			uploadRoot = new File(uploadRootPath);
			if (uploadRoot.exists()) {
				FileUtils.deleteDirectory(uploadRoot, true);
			}
			uploadRoot.mkdir();
			this.uploadRootPath = uploadRoot.getCanonicalPath();
		}else {
			throw new NullPointerException(Constants.UPLOAD_ROOT_CREATION_ERROR);
		}
	}
	
	void copyImages()throws IOException {
		FileUtils.copyDirectory(new File(imageSrc), uploadRoot);
	}
}